
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <netinet/ip.h>
#include <linux/sockios.h>
#include <linux/if_ether.h>
#include <linux/if_arp.h>

#define LAN_DEV		"eth1"
#define TRUE		1
#define FALSE		0
#define size_t		int
#define	BUFSIZE		2048

#define TCP_PHEADER_LEN 	14
typedef struct {
	unsigned int src;
	unsigned int dst;
	unsigned char mbz;
	unsigned char protocol;
	unsigned short length;
	unsigned short checksum;
} __attribute__ ((__packed__)) tcp_PseudoHeader;


void die(char *str);
void get_hw_addr(char *buf, char *str);
void SendArpPkt(char *dev, char *src_e_hw, char *dst_e_hw, int op, char *src_a_hw, char *src_a_ip, char *dst_a_hw, char *dst_a_ip);
void usage();
int getdevindex(int sock, char *name);
int strip(unsigned char *dst, char *str);

static u_int16_t csum_partial(void *buffer,
                              unsigned int len, u_int16_t prevsum);

static int queue_filter(unsigned char *ip_pkt, size_t buf_len, char *hw_addr);
static int http_filter(unsigned char *dp, unsigned int tcpdata_len);
static int build_http_response(char *buf, char *ip_pkt, int buf_len, char *hw_addr);
static int build_SYN_ACK(char *buf, char *ip_pkt, int buf_len, char *hw_addr);
static int build_FIN_ACK(char *buf, char *ip_pkt, int buf_len, char *hw_addr);
static int build_WAN_RST(char *ip_pkt, int buf_len);

static int packet_send(char *dev,char *dst_e_hw, int eth_type, char *buf, int len);

static void dump_iphdr(unsigned char *buf);

int http_raw=-1;
main(int argc, char *argv[])
{

	if ((http_raw = socket(PF_PACKET, SOCK_RAW, htons(ETH_P_ALL))) < 0)
		die("Can't create socket");

	run("eth1");			
}	

void tcp_handle_request()
{
	unsigned	addr_len;
	int             len;
    	int 		maxsize=BUFSIZE;

    	struct sockaddr_in from_addr;	
    	unsigned char inbuf[BUFSIZE];
    	char *hw_addr;
	struct ethhdr *eth_h;    	
    

    	len = recvfrom(http_raw, inbuf, maxsize, 0,
		   (struct sockaddr *)&from_addr, &addr_len);
    
     	if (len < 0) {
		//printf("recvfrom error %s", strerror(errno));
		printf("recvfrom error\n");		
		return;
    	}  
   	
    	eth_h = (struct ethhdr *)inbuf;	
    	//printf("got %d bytes, proto=%x\n", len, eth_h->h_proto);      	
    	if (eth_h->h_proto != ETH_P_IP)
    		return;

	//dump_ethhdr(inbuf);
	//dump_iphdr((inbuf+ETH_HLEN));    	
    	
    	hw_addr = inbuf+ETH_ALEN;	/* src MAC address */
    	if (len >= (ETH_HLEN)) 
    		len-=(ETH_HLEN); 
    	queue_filter((inbuf+ETH_HLEN)/* ip_pkt */, len, hw_addr);
    	
}    	

int http_filter(unsigned char *dp, unsigned int tcpdata_len)
{
    	int match_get = FALSE;

	if (tcpdata_len == 0)
		return match_get;
    	switch (*dp)
    	{
        	case 'G':
        		if (memcmp(dp, "GET", strlen("GET")) == 0) {
				match_get = TRUE;
			}	
            		break;
		default:
			break;
    	}
    	return match_get;			
}		

#define HTTP_RESPONSE1 "HTTP/1.1 302 Found"
#define HTTP_RESPONSE2 "Location: http://192.168.1.1/status.asp"
//#define BLOCK_PAGE	   "status.asp"
//#define BLOCK_PAGE	   "index.html"
#define BLOCK_PAGE_BLANKSTATE	"CA_Welcome.html"
#define BLOCK_PAGE_WAN_LAN_IP	"LIPChangeNotice.html"
#define BLOCK_PAGE_WATER_MARK		"WaterMarkNotice.html"
#define BLOCK_PAGE_LIMITED_REACHED	"LimitReachedNotice.html"
int build_http_response(char *buf, char *ip_pkt, int buf_len, char *hw_addr)
{
	
    	unsigned int len, iphdr_len, tcphdr_len, tcpdata_len;
    	struct iphdr * ip = (struct iphdr *)(ip_pkt);
    	struct tcphdr *tp;
    	unsigned short sport, dport;
    	unsigned char *dp;
    	unsigned int sourceIP, destIP;
    	unsigned int seq, ack;
    	char *ptr, *tcpdata_ptr;
    	char temp_str[80];
    	tcp_PseudoHeader ph;
    	int SmtWzdDone = 0, WL_ip_match= 0, LimitReached = 0;
    	char *file;

	SmtWzdDone = atoi(nvram_get("SmtWzdDone"));
	WL_ip_match = atoi(nvram_get("WL_ip_match"));	
#if defined(_TRAFFIC_METER_)	
	LimitReached = atoi(nvram_get("limited_reached"));
#endif	
	len = ntohs(ip->tot_len);
	if (len != (unsigned int) buf_len) {
		//printf("len = %d buf_len = %d  __LINE__ = %d\n", len, buf_len, __LINE__);
		return 0;
	}	
	
    	iphdr_len = (ip->ihl) << 2;									/* quadword to byte format */
    	tp = (struct tcphdr *)((unsigned char *)ip + iphdr_len);	/* tcp frame pointer */
    	tcphdr_len = (tp->doff) << 2;								/* quadword to byte format */
    	dp = (unsigned char *)tp + tcphdr_len;						/* point to data port */
    	tcpdata_len = len - iphdr_len - tcphdr_len;


	/* checnge ip header source/dest ip */
	sourceIP = ip->saddr;
	destIP = ip->daddr;
	ip->saddr = destIP;
	ip->daddr = sourceIP;
	
	/* change tcp header source/dest port */
    	sport = tp->source;
	dport = tp->dest;
	tp->source = dport;
	tp->dest = sport;

	/* adjust seq and ack */
	seq = tp->seq;
	ack = tp->ack_seq;
	tp->seq = ack;
	tp->ack_seq = htonl((ntohl(seq) + tcpdata_len));

	/* http response */
	/* build http response header */
	len = strlen(HTTP_RESPONSE1);
	tcpdata_ptr = (ip_pkt + (iphdr_len+tcphdr_len));
	ptr = tcpdata_ptr;
	memcpy(ptr, HTTP_RESPONSE1, len);
	ptr += len;
	*ptr++ = '\r';
	*ptr++ = '\n';

	//len = strlen(HTTP_RESPONSE2);
	//memcpy(ptr, HTTP_RESPONSE2, len);
	if (SmtWzdDone == 0) 
		file = BLOCK_PAGE_BLANKSTATE;
	else if (WL_ip_match == 1)
		file = BLOCK_PAGE_WAN_LAN_IP;
	else if (LimitReached == 1)
		file = BLOCK_PAGE_LIMITED_REACHED;
	else	
		file = BLOCK_PAGE_WATER_MARK;
			
		
	//sprintf(temp_str, "Location: http://%s/%s", nvram_get("lan_ipaddr"), ((SmtWzdDone == 0) ? BLOCK_PAGE_BLANKSTATE : BLOCK_PAGE_WAN_LAN_IP));
	sprintf(temp_str, "Location: http://%s/%s", nvram_get("lan_ipaddr"), file);
	len = strlen(temp_str);
	memcpy(ptr, temp_str, len);

	printf("Relocation to %s\n", temp_str);
	
	ptr += len;
	*ptr++ = '\r';
	*ptr++ = '\n';
	
	tcpdata_len = ((int)ptr) - ((int)tcpdata_ptr);
	ip->tot_len = htons(iphdr_len+tcphdr_len+tcpdata_len);

	/* ip checksum */
	ip->check = 0;
	ip->check = ~csum_partial(ip_pkt, sizeof(struct iphdr), 0);

	/* tcp checksum */
	ph.src = ip->saddr;
	ph.dst = ip->daddr;
	ph.mbz = 0;
	ph.protocol = 0x06;		/* TCP */
	ph.length = htons(tcphdr_len+tcpdata_len);
	
	tp->check = 0;
	ph.checksum = csum_partial((char *)tp, (tcphdr_len+tcpdata_len), 0);
    	tp->check = ~csum_partial((char *)&ph, TCP_PHEADER_LEN, 0);	
	
	return ntohs(ip->tot_len);
}

int build_SYN_ACK(char *buf, char *ip_pkt, int buf_len, char *hw_addr)
{
	
    	unsigned int len, iphdr_len, tcphdr_len, tcpdata_len;
    	struct iphdr * ip = (struct iphdr *)(ip_pkt);
    	struct tcphdr *tp;
	unsigned short sport, dport;
    	unsigned char *dp;
	unsigned int sourceIP, destIP;
	unsigned int seq, ack;
	char *ptr, *tcpdata_ptr;
	tcp_PseudoHeader ph;

	len = ntohs(ip->tot_len);
	if (len != (unsigned int) buf_len) {
		//printf("len = %d buf_len = %d  __LINE__ = %d\n", len, buf_len, __LINE__);
		return 0;
	}		
	
    	iphdr_len = (ip->ihl) << 2;									/* quadword to byte format */
    	tp = (struct tcphdr *)((unsigned char *)ip + iphdr_len);	/* tcp frame pointer */
    	tcphdr_len = (tp->doff) << 2;								/* quadword to byte format */
    	dp = (unsigned char *)tp + tcphdr_len;						/* point to data port */
    	tcpdata_len = len - iphdr_len - tcphdr_len;

	/* already changed by previous build (build_http_resp) */
#if 1	
	/* checnge ip header source/dest ip */
	sourceIP = ip->saddr;
	destIP = ip->daddr;
	ip->saddr = destIP;
	ip->daddr = sourceIP;
	
	/* change tcp header source/dest port */
    	sport = tp->source;
	dport = tp->dest;
	tp->source = dport;
	tp->dest = sport;
#endif

	/* send tcp SYN and ACK to br0 interface through raw socket */
	tp->syn = 1;
	tp->ack = 1;

	/* adjust seq and ack */
	seq = tp->seq;
	ack = tp->ack_seq;
	tp->seq = ack;
	tp->ack_seq = htonl((ntohl(seq) + 1));

	tcpdata_ptr = ip_pkt + (iphdr_len+tcphdr_len);
	ptr = tcpdata_ptr;
	
	/* tcpdata len always zero */
	tcpdata_len = ((int)ptr) - ((int)tcpdata_ptr);
	ip->tot_len = htons(iphdr_len+tcphdr_len+tcpdata_len);
	
	/* ipheader checksum */
	ip->check = 0;
	ip->check = ~csum_partial(ip_pkt, sizeof(struct iphdr), 0);

	/* tcp checksum */
	ph.src = ip->saddr;
	ph.dst = ip->daddr;
	ph.mbz = 0;
	ph.protocol = 0x06;		/* TCP */
	ph.length = htons(tcphdr_len+tcpdata_len);
	
	tp->check = 0;
	ph.checksum = csum_partial((char *)tp, (tcphdr_len+tcpdata_len), 0);
	tp->check = ~csum_partial((char *)&ph, TCP_PHEADER_LEN, 0); 
	
	return ntohs(ip->tot_len);
}	

int build_FIN_ACK(char *buf, char *ip_pkt, int buf_len, char *hw_addr)
{
	
    	unsigned int len, iphdr_len, tcphdr_len, tcpdata_len;
    	struct iphdr * ip = (struct iphdr *)(ip_pkt);
    	struct tcphdr *tp;
	//unsigned short sport, dport;
    	unsigned char *dp;
	//unsigned int sourceIP, destIP;
	unsigned int seq, ack;
	char *ptr, *tcpdata_ptr;
	tcp_PseudoHeader ph;

	len = ntohs(ip->tot_len);
	if (len != (unsigned int) buf_len) {
		//printf("len = %d buf_len = %d  __LINE__ = %d\n", len, buf_len, __LINE__);
		return 0;
	}		
	
    	iphdr_len = (ip->ihl) << 2;									/* quadword to byte format */
    	tp = (struct tcphdr *)((unsigned char *)ip + iphdr_len);	/* tcp frame pointer */
    	tcphdr_len = (tp->doff) << 2;								/* quadword to byte format */
    	dp = (unsigned char *)tp + tcphdr_len;						/* point to data port */
    	tcpdata_len = len - iphdr_len - tcphdr_len;

	/* already changed by previous build (build_http_resp) */
#if 0	
	/* checnge ip header source/dest ip */
	sourceIP = ip->saddr;
	destIP = ip->daddr;
	ip->saddr = destIP;
	ip->daddr = sourceIP;
	
	/* change tcp header source/dest port */
    	sport = tp->source;
	dport = tp->dest;
	tp->source = dport;
	tp->dest = sport;
#endif

	/* send tcp FIN and ACK to br0 interface through raw socket */
	tp->fin = 1;
	tp->ack = 1;
	tp->psh = 0;

	/* adjust seq and ack */
	seq = tp->seq;
	tp->seq = htonl((ntohl(seq) + tcpdata_len));

	tcpdata_ptr = ip_pkt + (iphdr_len+tcphdr_len);
	ptr = tcpdata_ptr;
	
	/* tcpdata len always zero */
	tcpdata_len = ((int)ptr) - ((int)tcpdata_ptr);
	ip->tot_len = htons(iphdr_len+tcphdr_len+tcpdata_len);
	
	/* ipheader checksum */
	ip->check = 0;
	ip->check = ~csum_partial(ip_pkt, sizeof(struct iphdr), 0);

	/* tcp checksum */
	ph.src = ip->saddr;
	ph.dst = ip->daddr;
	ph.mbz = 0;
	ph.protocol = 0x06;		/* TCP */
	ph.length = htons(tcphdr_len+tcpdata_len);
	
	tp->check = 0;
	ph.checksum = csum_partial((char *)tp, (tcphdr_len+tcpdata_len), 0);
	tp->check = ~csum_partial((char *)&ph, TCP_PHEADER_LEN, 0); 
	
	return ntohs(ip->tot_len);
}		

/* This is from gen_ip.c */
static u_int16_t csum_partial(void *buffer,
                              unsigned int len, u_int16_t prevsum)
{
	u_int32_t sum = 0;
	u_int16_t *ptr = buffer;
	
	while (len > 1)  {
		sum += *ptr++;
		len -= 2;
	}
	if (len) {
		union {
			u_int8_t byte;
			u_int16_t wyde;
		} odd;
	
		odd.wyde = 0;
		odd.byte = *((u_int8_t *)ptr);
		sum += odd.wyde;
	}
	sum = (sum >> 16) + (sum & 0xFFFF);
	sum += prevsum;
	return (sum + (sum >> 16));
}
    	
    	
int queue_filter(unsigned char *ip_pkt, size_t buf_len, char *hw_addr)
{
    	unsigned int len, iphdr_len, tcphdr_len, tcpdata_len;
    	struct iphdr * ip = (struct iphdr *)(ip_pkt);
    	struct tcphdr *tp;
	unsigned short dport;
    	unsigned char *dp;
	unsigned int sourceIP, destIP;
	int verdict;    
	char *my_pkt;	
	int build_type=-1;
	
    	struct in_addr ipnum;

	len = ntohs(ip->tot_len);
	if (len != (unsigned int) buf_len) {
		//printf("len = %d buf_len = %d  __LINE__ = %d\n", len, buf_len, __LINE__);
		return 0;
	}
	
	if (ip->protocol != 6)
		return 0;
	
    	iphdr_len = (ip->ihl) << 2;									/* quadword to byte format */
    	tp = (struct tcphdr *)((unsigned char *)ip + iphdr_len);	/* tcp frame pointer */
    	tcphdr_len = (tp->doff) << 2;								/* quadword to byte format */
    	dp = (unsigned char *)tp + tcphdr_len;						/* point to data port */
    	tcpdata_len = len - iphdr_len - tcphdr_len;

	//printf("iphdr_len = %d, tcphdr_len = %d, tcpdata_len = %d\n",
	//	   iphdr_len, tcphdr_len, tcpdata_len);	

	sourceIP = ip->saddr;
	destIP = ip->daddr;
	
	inet_aton(nvram_get("lan_ipaddr"), &ipnum);	
	if (destIP == ipnum.s_addr) {
		//printf("destIP = %s\n", nvram_get("lan_ipaddr"));
		return 0;
	}	

	if ((tcpdata_len == 0)) {
			if (tp->syn) {
				//printf("syn flag received\n");
				build_type = 0;		/* reply SYN ACK */			
			}	  	
			if (tp->ack) {
				//printf("ack flag received\n");
			}	
			if (tp->fin) {
				//printf("fin flag received\n");
			}	
			if (tp->rst) {
				//printf("syn rst received\n");
			}
	}
	dport = ntohs(tp->dest);
	
	switch (dport)
	{
		case 80 :
			if ((tcpdata_len == 0) && (build_type == -1)) 
				return 0;			
			if (http_filter(dp, tcpdata_len)) {
				printf("http GET method...\n");
				build_type = 1;		/* reply GET */ 
			}	
			break;
		default :
			return 0;
	}
	
	my_pkt = (char *)malloc(BUFSIZE);
	if (my_pkt == NULL) {
		printf("can't malloc __LINE__ : %d\n", __LINE__);
		return 0;
	}	
        memcpy(my_pkt, ip_pkt, buf_len);
        
        switch (build_type) {
        	case 0:
        		len = build_SYN_ACK(my_pkt, my_pkt, buf_len, hw_addr);
 			packet_send(LAN_DEV, hw_addr, ETH_P_IP, my_pkt, len);       		
 			break;
 		case 1:
			/* relocation http response */
			len = build_http_response(my_pkt, my_pkt/*packet*/, buf_len, hw_addr);
			packet_send(LAN_DEV, hw_addr, ETH_P_IP, my_pkt, len);
			/* close LAN side connections (FIN ACK flag) */
			len = build_FIN_ACK(my_pkt, my_pkt/*packet*/, len, hw_addr);
			packet_send(LAN_DEV, hw_addr, ETH_P_IP, my_pkt, len);
			break;
	}		
	free((void *)my_pkt);
	return 0;	  
	  
}	

void run(char *dev)
{
  	struct timeval     tout;
  	fd_set             fdread;
  	int                retn;
  	int		   maxsock;
	struct ifreq interface;  	


	strncpy(interface.ifr_ifrn.ifrn_name, dev, IFNAMSIZ);
	if (setsockopt(http_raw, SOL_SOCKET, SO_BINDTODEVICE,(char *)&interface, sizeof(interface)) < 0) {
		//close(fd);
		//return -1;
	}	
  	FD_ZERO(&fdread);
  	FD_SET(http_raw,  &fdread); 
  	maxsock = http_raw; 

  	while(1) {
    		tout.tv_sec  = 0;
    		tout.tv_usec = 0;
    
    		/* Wait for input or timeout */
    		retn = select(maxsock+1, &fdread, 0, 0, NULL);
    		/* Handle errors */
    		if (retn < 0) {
      			//printf("select returned %s", strerror(errno));
      			printf("select returned %d", retn);
      			continue;
    		}
    		else if (retn != 0) {
     		
		       	/* Check for new HTTP queries */
      			if (FD_ISSET(http_raw, &fdread)) {
				tcp_handle_request();
       			}
		}
	}	
		
}


void die(char *str)
{
	fprintf(stderr, "\nAttention exit for the followent reason : %s\n", str);
	//exit(0);
	return (-1);
}

int getdevindex(int sock, char *name)
{
	struct ifreq ifr;

	memset(&ifr, 0, sizeof(ifr));
	strncpy(ifr.ifr_name, name, sizeof(ifr.ifr_name));

	if(ioctl(sock, SIOCGIFINDEX, &ifr) == -1) 
		die("I can't get device flags...");
	//fprintf(stderr, "Get ethernet flags...\n");
	return ifr.ifr_ifindex;
}


int strip(unsigned char *dst, char *str)
{
	if (sscanf(str, "%d.%d.%d.%d", &dst[0], &dst[1], &dst[2], &dst[3]) == 4)
		return 0;
	return -1; 
			
}


#define MAX_SIZE	2048
int packet_send(char *dev,char *dst_e_hw, int eth_type, char *buf, int len)
{
	
	struct sockaddr_ll to;
	int sock;
	struct ifreq ifr;
	int i;
	char *send_pkt;


	//if ((sock = socket(AF_INET, SOCK_RAW, IPPROTO_RAW)) < 0)
	if ((sock = socket(PF_PACKET, SOCK_RAW, htons(ETH_P_ALL))) < 0)
		die("Can't create socket...");
	memset(&ifr, 0, sizeof(ifr));
	ifr.ifr_addr.sa_family = AF_INET;
	
	//printf("dev = %s\n", dev);
	if ((to.sll_ifindex = getdevindex(sock, dev)) == -1) {
		close(sock);
		die("Can't get interface");
	}

	strncpy(ifr.ifr_name, dev, sizeof(ifr.ifr_name));
	ifr.ifr_ifindex = to.sll_ifindex;
	if (ioctl(sock, SIOCGIFHWADDR, &ifr) == -1) {
		printf("Can't get %s hwaddr\n", dev);
		//exit(0);
		return (-1);
	}

	send_pkt = (char *)malloc(MAX_SIZE);
	if (send_pkt == NULL) {
		printf("malloc error ...\n");
		close(sock);
		return (-1);
	}	
	//get_hw_addr(send_pkt, dst_e_hw);
	memcpy(send_pkt, dst_e_hw, ETH_ALEN);
	memcpy(send_pkt+ETH_ALEN, ifr.ifr_hwaddr.sa_data, ETH_ALEN);
	*((unsigned short *)(send_pkt+ETH_ALEN*2)) = htons(eth_type);
	memcpy((char *)(send_pkt+ETH_HLEN), buf, len);
	
	if (sendto(sock, send_pkt, (len+ETH_HLEN), 0, (struct sockaddr *)&to, sizeof(to)) < 0) {
		free((void *)send_pkt);
		close(sock);
		die("I can't send pkt");
	}
	free((void *)send_pkt);
	close(sock);
}


static void dump_ethhdr(unsigned char *buf)
{
	struct ethhdr *eth_h = (struct ethhdr *)buf;	
	
	fputs("Dumping Ethernet Header:\n", stderr);	
	fprintf(stderr, "Dest %02x:%02x:%02x:%02x:%02x:%02x\n", eth_h->h_dest[0],
					eth_h->h_dest[1],eth_h->h_dest[2],eth_h->h_dest[3],
					eth_h->h_dest[4],eth_h->h_dest[5]);
	fprintf(stderr, "Source %02x:%02x:%02x:%02x:%02x:%02x\n", eth_h->h_source[0],
					eth_h->h_source[1],eth_h->h_source[2],eth_h->h_source[3],
					eth_h->h_source[4],eth_h->h_source[5]);
					
	fprintf(stderr, "Eth Type %04x\n", eth_h->h_proto);
}
	
/* 
 * This does not handle IP options yet, although it may at some point 
 * in the near future.  Some of this code was stolen from ipt_LOG.c.
 */
static void dump_iphdr(unsigned char *buf)
{
	struct iphdr *iph = (struct iphdr *)buf;

	fputs("Dumping IP Header:\n", stderr);
	fprintf(stderr, "VER=%u HLEN=%u TOS=0x%02hX TLEN=%u ID=%u ",
	        iph->version,
	        iph->ihl * 4,
	        iph->tos, 
	        ntohs(iph->tot_len),
	        ntohs(iph->id));
	if (ntohs(iph->frag_off) & IP_DF)
		fputs("DF ", stderr);
	if (ntohs(iph->frag_off) & IP_MF)
		fputs("MF ", stderr);
	if (ntohs(iph->frag_off) & 0x1FFF)
		fprintf(stderr, "FRAG=%u ",
		        (ntohs(iph->frag_off) & 0x1FFF) * 8);
	fprintf(stderr, "TTL=%u PROT=%u CSUM=0x%04X ",
	        iph->ttl,
	        iph->protocol,
	        ntohs(iph->check));
	fprintf(stderr, "SRC=%u.%u.%u.%u DST=%u.%u.%u.%u\n\n",
	        (ntohl(iph->saddr) >> 24) & 0xFF,
	        (ntohl(iph->saddr) >> 16) & 0xFF,
	        (ntohl(iph->saddr) >> 8) & 0xFF,
	        (ntohl(iph->saddr)) & 0xFF,
	        (ntohl(iph->daddr) >> 24) & 0xFF,
	        (ntohl(iph->daddr) >> 16) & 0xFF,
	        (ntohl(iph->daddr) >> 8) & 0xFF,
	        (ntohl(iph->daddr)) & 0xFF);
}
