
/*
*/

#include <stdio.h>
#include <errno.h>
#include <syslog.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>

#include <dni_shutils.h>
#include <dni_nvram.h>
#include "rc.h"
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <dni_netconf.h>
#include <pathnames.h>
//#include <rtl8651_tblDrv.h>

#ifdef	USE_NETCONF
static void AddHASPort( char *hasIP, unsigned short usHeartbeatPort);
static void DelHASPort( char *hasIP, unsigned short usHeartbeatPort);
#else

static void AddHASPort( char *hasIP, char *heartbeatPort);
static void DelHASPort( char *hasIP, char *heartbeatPort);
#endif  //#ifdef	USE_NETCONF

int
start_heartbeat()
{
	FILE *fp;
	int ret;
	char authserver[80];
	char authdomain[80];
	int iHB_state;

	if(nvram_invmatch("wan_proto", "telstra"))	return 0;

	//openlog("bpalogin", LOG_PID | LOG_NDELAY, LOG_DAEMON);
	authdomain[0] = 0;
	authserver[0] = 0;

//note by dvd.chen,
//Netgear's GUI has 1 field only for bpalog server,
//user can input 1. IP_address, 2. URL
// 3. NOTHING (system will show the default host name:sm-server, and we must attach 
//		the domain name from dhcpc message)
#if 0  
	/* We must find out HB auth server from domain that get by dhcp if user don't input HB sever. */
	if(nvram_invmatch("heartbeat_server", "") && nvram_invmatch("heartbeat_server", "0.0.0.0")){
		snprintf(authserver, sizeof(authserver), "%s", nvram_safe_get("heartbeat_server"));
		iHB_state=atoi(nvram_get("heartbeat_state"));
		switch(iHB_state)
		{
			case 1:
				snprintf(authdomain, sizeof(authdomain), "%s", "nsw.bigpond.net.au");
				break;
			case 2:
				snprintf(authdomain, sizeof(authdomain), "%s", "vic.bigpond.net.au");
				break;
			case 3:
				snprintf(authdomain, sizeof(authdomain), "%s", "qld.bigpond.net.au");
				break;
			case 4:
				snprintf(authdomain, sizeof(authdomain), "%s", "sa.bigpond.net.au");
				break;
			case 5:
				snprintf(authdomain, sizeof(authdomain), "%s", "vic.bigpond.net.au");
				break;
			case 6:
				snprintf(authdomain, sizeof(authdomain), "%s", "wa.bigpond.net.au");
				break;
			default:  //0
				authdomain[0] = 0;
				break;
		}
	}
	else if(nvram_match("heartbeat_state", "1")){            // NSW
		snprintf(authserver, sizeof(authserver), "%s", "spr3");
		snprintf(authdomain, sizeof(authdomain), "%s", "nsw.bigpond.net.au");
	}
	else if(nvram_match("heartbeat_state", "2")){           // Victoria
		snprintf(authserver, sizeof(authserver), "%s", "mer3");
		snprintf(authdomain, sizeof(authdomain), "%s", "vic.bigpond.net.au");
	}
	else if(nvram_match("heartbeat_state","3")){            // Queensland
		snprintf(authserver, sizeof(authserver), "%s", "bcr3");
		snprintf(authdomain, sizeof(authdomain), "%s", "qld.bigpond.net.au");
	}
	else if(nvram_match("heartbeat_state", "4")){            // South Austrialia
		snprintf(authserver, sizeof(authserver), "%s", "afr3");
		snprintf(authdomain, sizeof(authdomain), "%s", "sa.bigpond.net.au");
	}
	else if(nvram_match("heartbeat_state", "5")){           // Victoria
		snprintf(authserver, sizeof(authserver), "%s", "mer3");
		snprintf(authdomain, sizeof(authdomain), "%s", "vic.bigpond.net.au");
	}
	else if(nvram_match("heartbeat_state", "6")){            // Western Austrialia
		snprintf(authserver, sizeof(authserver), "%s", "pwr3");
		snprintf(authdomain, sizeof(authdomain), "%s", "wa.bigpond.net.au");
	}
	else{
		snprintf(authserver, sizeof(authserver), "%s", nvram_safe_get("wan_gateway"));
		snprintf(authdomain, sizeof(authdomain), "%s", "");
	}
#else
	
	#if 0  //for test only
	//snprintf(authserver, sizeof(authserver), "%s", "");
	snprintf(authdomain, sizeof(authdomain), "%s", nvram_safe_get("wan_domain"));
	cprintf("start_heartbeat:: authHost :: %s.%s\n", authserver, authdomain);
	#else
	if(nvram_invmatch("wan_tel_service", "") && nvram_invmatch("wan_tel_service", "0.0.0.0"))
	{
		snprintf(authserver, sizeof(authserver), "%s", nvram_safe_get("wan_tel_service"));
	}
	
	//get authdomain from dhcpc wan domain
	snprintf(authdomain, sizeof(authdomain), "%s", nvram_safe_get("wan_domain"));  
	#endif
	
#endif
	
	//syslog(LOG_DEBUG, "heartbeat: authserver[%s] authdomain[%s]\n", authserver, authdomain);
	if (!(fp = fopen("/tmp/bpalogin.conf", "w"))) {
		perror("/tmp/bpalogin.conf");
		return errno;
	}
#if 0  //for test only
	fprintf(fp, "username %s\n", "dvd");
	fprintf(fp, "password %s\n", "dvd");
#else  //for test only
	fprintf(fp, "username %s\n", nvram_safe_get("wan_tel_username"));
	fprintf(fp, "password %s\n", nvram_safe_get("wan_tel_password"));
#endif

//added by dvd.chen on 01/11/2006 for bpa idle timeout
	fprintf(fp, "idle_interval %s\n", nvram_safe_get("wan_tel_idle_interval"));
//end of dvd.chen
	if( strlen(authserver)>0 )
		fprintf(fp, "authserver %s\n", authserver);
	//fprintf(fp, "%cauthdomain %s\n", strcmp(authdomain,"") ? '\0' : '#', authdomain);
	if( strlen(authdomain)>0 )
		fprintf(fp, "authdomain %s\n", authdomain);
	fprintf(fp, "localport %d\n", HEARBEAT_LOCAL_PORT);
#ifdef REMOTE_SYSLOG_DEBUG
	fprintf(fp, "logging syslog\n");
#else
	fprintf(fp, "logging stdout\n");
#endif
	fprintf(fp, "debuglevel 0\n");  //no debug
	//fprintf(fp, "debuglevel 2\n");  //no debug
	
	fprintf(fp, "minheartbeatinterval 60\n");
	fprintf(fp, "maxheartbeatinterval 420\n");
	fprintf(fp, "connectedprog hb_connect\n"); 
	fprintf(fp, "disconnectedprog hb_disconnect\n");
	//fprintf(fp, "pingGatewayIP %s\n", nvram_safe_get("wan0_gateway"));  //dvd.chen
	
	fclose(fp);
	
	//mkdir("/etc/ppp", 0777);
	
	eval("killall", "-9", "bpalogin");
	sleep(1);
	ret = eval("bpalogin", "-c", "/tmp/bpalogin.conf");

#if 0
	if (nvram_invmatch("wan_ppp_demand", "1")) {
		if(status != REDIAL)
			start_redial();	
	}
#endif

	return ret;
}
/*moved to services.c for MonTask by kane.chen*/
#if 0
int
stop_heartbeat(void)
{
	int ret;

	unlink("/etc/ppp/link.ppp0");
	unlink("/var/run/bpalogin.pid");
	
	ret = eval("killall", "bpalogin");  //send signal:TERM to bpalogin task, it will trigger the logout process
	sleep( 2 );
	ret += eval("killall", "-9", "bpalogin");

	//openlog("bpalogin", LOG_PID | LOG_NDELAY, LOG_DAEMON);
	//closelog();

	log_WAN_connect("WAN Telstra BigPond Disconnected");

	dprintf("done\n");
	
	return ret;
}
#endif
/*
 *  Called when link comes up
 *  argv[1] : listenport
 *  argv[2] : pid
 */
int
hb_connect_main(int argc, char **argv)
{
	FILE *fp;
	
	cprintf("Enter hb_connect_main\n");
	
	//openlog("bpalogin" ,LOG_PID, LOG_DAEMON);
	

//	mkdir("/etc/ppp", 0777);
	mkdir(PID_PATH, 0777);

	/* Touch connection file */
//	if (!(fp = fopen("/etc/ppp/link.ppp0", "a"))) {
	if (!(fp = fopen(PPP_LINK_PATH"bpa", "a"))) {
                perror(PPP_LINK_PATH"bpa");
                return errno;
        }
	//fprintf(fp, "%s", argv[2]);
        fclose(fp);
	
	//start_wan_done(nvram_safe_get("wan_ifname"));  //vlan1
	wan_up(nvram_safe_get("wan0_ifname"));  //vlan1, dvd.chen

#ifdef	USE_NETCONF
	AddHASPort(argv[1], (unsigned short )atol( argv[2]));
#else
	AddHASPort(argv[1], argv[2]);
#endif
	/*
	//add udp:5050 to iptable
	snprintf(buf, sizeof(buf), "iptables -I INPUT -d %s -i %s -p udp --dport %d -j %s", 
		   nvram_safe_get("wan0_ipaddr"), 
		   nvram_safe_get("wan0_ifname"),   //vlan1
		   5050, 
		   "ACCEPT");
	cprintf("\nExecuting external command: \n%s\n",buf);
	system(buf);
	*/


	rtl8651_flushDemandRoute(5);		
	//log bpalogin wan_up here
	//log_WAN_connect("WAN Telstra BigPond Connected");
	log_message("WAN Telstra BigPond Connected");
	setLedLight(WAN_LED, LED_GREEN);	
	
	
	return TRUE;	
}

/*
 *  * Called when link goes down
 *   */
// arg[1]: heartbeat server IP
// arg[2]: local listen port
// argv[3]: reason
int
hb_disconnect_main(int argc, char **argv)
{	
	cprintf("Enter hb_disconnect_main, reason [%ld]\n", atol(argv[3]));
	
	//openlog("heartbeat" ,LOG_PID, LOG_DAEMON);
	/*
	//delete udp:5050 from iptable
	snprintf(buf, sizeof(buf), "iptables -D INPUT -d %s -i %s -p udp --dport %d -j %s", 
		   nvram_safe_get("wan0_ipaddr"), 
		   nvram_safe_get("wan0_ifname"),   //vlan1
		   5050, 
		   "ACCEPT");
	cprintf("\nExecuting external command: \n%s\n",buf);
	system(buf);
	*/
	
	//stop_wan();
	//stop_heartbeat();
	//logout_heartbeat();  //dvd.chen
#ifdef	USE_NETCONF
	DelHASPort( argv[1], (unsigned short )atol( argv[2]) );
#else
	DelHASPort( argv[1], argv[2] );
#endif

	
	if ((atoi(nvram_get("auto_connect")) == 1) && (atoi(nvram_get("wan_tel_manualHangup")) == 0)) {
		AddDemandRoute(5, 1);
	}
	//log bpalogin wan_down here
	//log_WAN_connect("WAN Telstra BigPond Disconnected");
	log_message("WAN Telstra BigPond Disconnected");	
	setLedLight(WAN_LED, LED_AMBER);	
		
	return unlink(PPP_LINK_PATH"bpa");	/* /tmp/ppp/link.ppp0 */
}

#ifdef	USE_NETCONF
void AddHASPort( char *hasIP, unsigned short usHeartbeatPort)
{
netconf_filter_t filter;

	memset(&filter, 0, sizeof(filter));
	strcpy( filter.match.in.name, nvram_safe_get("wan0_ifname") );
	filter.match.ipproto = IPPROTO_UDP;
	if( hasIP )
	{
		inet_aton( hasIP, &filter.match.src.ipaddr );
		filter.match.src.netmask.s_addr =  htonl(0xffffffff);
	}
	filter.match.src.ports[1] = htons(0xffff); // sport: from 0 to 0xffff
	filter.match.dst.ports[0] = htons(usHeartbeatPort); 		// echo request
	filter.match.dst.ports[1] = htons(usHeartbeatPort);
	filter.target = NETCONF_ACCEPT;
	filter.dir = NETCONF_IN;
	netconf_add_filter( &filter );
	cprintf("%s:: Add target INPUT\n", __FUNCTION__ );	
}
#else

//note by dvd.chen, these defines are org in rtl8651_tblDrv.h
#define PS_ACTION_CLIENT 1
#define PS_ACTION_DONT_TIMEOUT 3
void AddHASPort( char *hasIP, char *heartbeatPort)
{
#if 0
	//-A input_accept -i eth1 -p udp --dport 5050 -m state --state NEW -j ACCEPT 
	char *argvec[] = { "/sbin/iptables", "-A", IPTC_INPUT_ACCEPT, "-i", NULL, 
					"-p", "udp", "--destination-port", NULL, 
					"-m", "state", "--state",  "NEW", "-j", "ACCEPT", NULL};
	argvec[4] = nvram_safe_get("wan0_ifname");
	argvec[8] = heartbeatPort;
	vEval( argvec );
#else
	int ret;

	//To make udp-5050 NOT update the registered idle_timeer, make idle_timeout work properly  
	ret = rtl8651_addProtoStackActions(0,0xffffffff,PS_ACTION_DONT_TIMEOUT,PS_ACTION_CLIENT,IPPROTO_UDP,5050,5050);
	if(ret)
		cprintf("%s::rtl8651_addProtoStackActions FAILED,ret[%d]\n", __FUNCTION__, ret);
	else
		cprintf("%s::rtl8651_addProtoStackActions SUCCEED\n", __FUNCTION__);
#endif
}
#endif  //#ifdef	USE_NETCONF

#ifdef	USE_NETCONF
void DelHASPort( char *hasIP, unsigned short usHeartbeatPort)
{
netconf_filter_t filter;

	memset(&filter, 0, sizeof(filter));
	strcpy( filter.match.in.name, nvram_safe_get("wan0_ifname") );
	filter.match.ipproto = IPPROTO_UDP;
	if( hasIP )
	{
		inet_aton( hasIP, &filter.match.src.ipaddr );
		filter.match.src.netmask.s_addr =  htonl(0xffffffff);
	}
	filter.match.src.ports[1] = htons(0xffff); // sport: from 0 to 0xffff
	filter.match.dst.ports[0] = htons(usHeartbeatPort); 		// echo request
	filter.match.dst.ports[1] = htons(usHeartbeatPort);
	filter.target = NETCONF_ACCEPT;
	filter.dir = NETCONF_IN;
	netconf_del_filter( &filter );
	cprintf("%s:: Del target INPUT\n", __FUNCTION__ );
}
#else
void DelHASPort( char *hasIP, char *heartbeatPort)
{
#if 0
	//-D input_accept -i eth1 -p udp --dport 5050 -m state --state NEW -j ACCEPT
	char *argvec[] = { "/sbin/iptables", "-D", IPTC_INPUT_ACCEPT, "-i", NULL, 
					"-p", "udp", "--destination-port", NULL, 
					"-m", "state", "--state",  "NEW", "-j", "ACCEPT", NULL};
	argvec[4] = nvram_safe_get("wan0_ifname");
	argvec[8] = heartbeatPort;
	vEval( argvec );
#else
	int ret;

	//ret = rtl8651_delProtoStackActions(ipaddr_t lowerIp, ipaddr_t upperIp, uint8 action, uint8 role, uint8 protocol, uint16 orgPort, uint16 fwdPort)
	if(ret)
		cprintf("%s::rtl8651_delProtoStackActions FAILED, ret[%d]\n", __FUNCTION__,ret);
	else
		cprintf("%s::rtl8651_delProtoStackActions SUCCEED\n", __FUNCTION__);
#endif
}
#endif  //#ifdef	USE_NETCONF

