/*
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <net/route.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>
#include <time.h>
#include <unistd.h>

#include <dni_nvram.h>
//#include <netconf.h>
#include <dni_shutils.h>
#include <net/if.h>
#include "rc.h"
#include <sys/file.h> //Brian+
#include <sys/types.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <unistd.h>
#include <signal.h>  //added by dvd.chen

#if 0  //moved to shutils.c
#ifdef __CONFIG_NAT__
void log_dhcp(char *client) //Brian+: write dhcp info into log file
{
	int fp;
	time_t timep;
	char buf[200];
	char cont[300];
	struct stat status;

	fp = open("/tmp/sys_log", O_RDWR|O_CREAT|O_APPEND); 
	if (fp == -1)
		cprintf("open file failed!!\n");
	else
	{
		int len;

		fstat(fp, &status);
		if (status.st_size < 4096)
		{
			//flock(fp,LOCK_EX);
			sys_flock(fp, LOCK_EX); //Brian: change flock() to sys_flock
			time(&timep);
			memset(buf,0,sizeof(buf));
			strcpy(buf, ctime(&timep));

			/* remove line feed char */
			len = strlen(buf);
			buf[len-1]='\0';

			//	sprintf(cont, "%s -WAN DHCP Client Connected IP %s\n", buf,IP);  
			sprintf(cont, "%s -WAN DHCP Client Connected IP %s\n", buf, client);

			write(fp, cont, strlen(cont)); 		  
			flock(fp,LOCK_UN);
		}
	} 
	close(fp);
}
#endif __CONFIG_NAT__
#endif


#ifdef __CONFIG_NAT__
static int expires(char *wan_ifname, unsigned int in)
{
	time_t now;
	FILE *fp;
	char tmp[100];
	int unit = 0;

	//if ((unit = wan_ifunit(wan_ifname)) < 0)
	//	return -1;
	
	time(&now);
	snprintf(tmp, sizeof(tmp), "/tmp/udhcpc%d.expires", unit); 
	if (!(fp = fopen(tmp, "w"))) {
		perror(tmp);
		return errno;
	}
	fprintf(fp, "%d", (unsigned int) now + in);
	fclose(fp);
	return 0;
}	

/* 
 * deconfig: This argument is used when udhcpc starts, and when a
 * leases is lost. The script should put the interface in an up, but
 * deconfigured state.
*/
static int
deconfig(void)
{
	char *wan_ifname = safe_getenv("interface");

	ifconfig(wan_ifname, IFUP,
		 "0.0.0.0", NULL);
	expires(wan_ifname, 0);

	wan_down(wan_ifname);

	dprintf("done\n");
	return 0;
}

/*
 * bound: This argument is used when udhcpc moves from an unbound, to
 * a bound state. All of the paramaters are set in enviromental
 * variables, The script should configure the interface, and set any
 * other relavent parameters (default gateway, dns server, etc).
*/
static int
bound(void)
{
	char *wan_ifname = safe_getenv("interface");
	char *value;
	char tmp[100], prefix[] = "wanXXXXXXXXXX_";
	int unit = 0;
	FILE *fp;
	char *pstrWanLastIP;

	//if ((unit = wan_ifunit(wan_ifname)) < 0)
	//	return -1;

	snprintf(prefix, sizeof(prefix), "wan%d_", unit);
		
	if ((value = getenv("ip")))
		nvram_set(strcat_r(prefix, "ipaddr", tmp), trim(value));
	if ((value = getenv("subnet")))
		nvram_set(strcat_r(prefix, "netmask", tmp), trim(value));
        if ((value = getenv("router")))
		nvram_set(strcat_r(prefix, "gateway", tmp), trim(value));
	//modified by dvd.chen, if wan_autodns is 0 ==> don't change it, cause we gonna use manual setting
	//if ((value = getenv("dns")))
	if( atoi(nvram_get("wan_autodns"))==1 && (value = getenv("dns")) )
		nvram_set(strcat_r(prefix, "dns", tmp), trim(value));
	if ((value = getenv("wins")))
		nvram_set(strcat_r(prefix, "wins", tmp), trim(value));
	if ((value = getenv("hostname")))
		sethostname(value, strlen(value) + 1);
	if ((value = getenv("domain")))
		nvram_set(strcat_r(prefix, "domain", tmp), value);
	if ((value = getenv("lease"))) {
		nvram_set(strcat_r(prefix, "lease", tmp), value);
		expires(wan_ifname, atoi(value));
	}
	
	//cprintf("%s::wan_ifname:%s, wan0_ip:%s\n", __FUNCTION__, wan_ifname, nvram_get("wan0_ipaddr"));

	// Added by wayne.lu on 
	pstrWanLastIP = file2str( "/tmp/WanLastIPAddr" );
	if( pstrWanLastIP && !strcmp( pstrWanLastIP, getenv("ip") ) )
	{
		// Same as last bound
		free( pstrWanLastIP );
		return 0;
	}

	free( pstrWanLastIP );
	
	ifconfig(wan_ifname, IFUP,
		 nvram_safe_get(strcat_r(prefix, "ipaddr", tmp)),
		 nvram_safe_get(strcat_r(prefix, "netmask", tmp)));
	
	if(nvram_match("wan_proto", "heartbeat"))
	{

		int i=0;
		if( !(fp=fopen("/var/run/bpalogin.pid", "r")) )
		{
			char sig[5];

			//added by dvd.chen on 08/31/2004
			//to reset g_hearbeat_is_listening to 0
			sprintf(sig, "-%d", SIGUSR2);
    			eval("killall",sig,"CheckWan");  //signal CheckWan task that now is NOT listening lan interface
    			//end of dvd.chen
			
			/* Delete all default routes */
		        while (route_del(wan_ifname, 0, NULL, NULL, NULL) == 0 || i++ < 10);
		
			/* Set default route to gateway if specified */
		        route_add(wan_ifname, 0, "0.0.0.0", nvram_safe_get("wan0_gateway"), "0.0.0.0");

		        /* save dns to resolv.conf */
			//dns_to_resolv();  
			add_ns(wan_ifname);	//dvd.chen
						
			printf("calling start_heartbeat, wan_ifname: %s\n", wan_ifname);
			//start_heartbeat(BOOT);
			start_heartbeat();

		}
		else
		{
			fclose(fp);
			wan_up(wan_ifname);
		}

	}
	else
	{
		wan_up(wan_ifname);
	}

	// cprintf("done\n");
	return 0;
}

/*
 * renew: This argument is used when a DHCP lease is renewed. All of
 * the paramaters are set in enviromental variables. This argument is
 * used when the interface is already configured, so the IP address,
 * will not change, however, the other DHCP paramaters, such as the
 * default gateway, subnet mask, and dns server may change.
 */
static int
renew(void)
{
	bound();

	dprintf("done\n");
	return 0;
}

int
udhcpc_wan(int argc, char **argv)
{
	static	int ret_val;
	char prefix[] = "wanXXXXXXXXXX_",tmp[100];
	char *wan_ifname = safe_getenv("interface");
	int unit;
	char log_msg[64];

	if (!argv[1])
		return EINVAL;
	else if (strstr(argv[1], "deconfig"))
		return deconfig();
	else if (strstr(argv[1], "bound")) 
	{
		ret_val = bound();

		//if ((unit = wan_ifunit(wan_ifname)) < 0)
		//	return -1;
		unit = 0;

		snprintf(prefix, sizeof(prefix), "wan%d_", unit);
	    //log_dhcp(nvram_safe_get(strcat_r(prefix, "ipaddr", tmp))); //Brian+: write dhcp log
		sprintf( log_msg, "WAN DHCP Connected, IP: %s", nvram_safe_get(strcat_r(prefix, "ipaddr", tmp)) );
		log_WAN_connect(log_msg);
		return ret_val;
	}
	else if (strstr(argv[1], "renew"))
		return renew();
	else
		return EINVAL;
}
#else
static int
expires_lan(char *lan_ifname, unsigned int in)
{
	time_t now;
	FILE *fp;
	char tmp[100];

	time(&now);
	snprintf(tmp, sizeof(tmp), "/tmp/udhcpc-%s.expires", lan_ifname); 
	if (!(fp = fopen(tmp, "w"))) {
		perror(tmp);
		return errno;
	}
	fprintf(fp, "%d", (unsigned int) now + in);
	fclose(fp);
	return 0;
}	

/* 
 * deconfig: This argument is used when udhcpc starts, and when a
 * leases is lost. The script should put the interface in an up, but
 * deconfigured state.
*/
static int
deconfig_lan(void)
{
	char *lan_ifname = safe_getenv("interface");

	ifconfig(lan_ifname, IFUP, "0.0.0.0", NULL);
	expires_lan(lan_ifname, 0);

	lan_down(lan_ifname);

	dprintf("done\n");
	return 0;
}

/*
 * bound: This argument is used when udhcpc moves from an unbound, to
 * a bound state. All of the paramaters are set in enviromental
 * variables, The script should configure the interface, and set any
 * other relavent parameters (default gateway, dns server, etc).
*/
static int
bound_lan(void)
{
	char *lan_ifname = safe_getenv("interface");
	char *value;
	
	if ((value = getenv("ip")))
		nvram_set("lan_ipaddr", value);
	if ((value = getenv("subnet")))
		nvram_set("lan_netmask", value);
        if ((value = getenv("router")))
		nvram_set("lan_gateway", value);
	if ((value = getenv("lease")))
		expires_lan(lan_ifname, atoi(value));

	ifconfig(lan_ifname, IFUP, nvram_safe_get("lan_ipaddr"),
		nvram_safe_get("lan_netmask"));

	lan_up(lan_ifname);

	dprintf("done\n");
	return 0;
}

/*
 * renew: This argument is used when a DHCP lease is renewed. All of
 * the paramaters are set in enviromental variables. This argument is
 * used when the interface is already configured, so the IP address,
 * will not change, however, the other DHCP paramaters, such as the
 * default gateway, subnet mask, and dns server may change.
 */
static int
renew_lan(void)
{
	bound_lan();

	dprintf("done\n");
	return 0;
}

/* dhcp client script entry for LAN (AP) */
int
udhcpc_lan(int argc, char **argv)
{
	if (!argv[1])
		return EINVAL;
	else if (strstr(argv[1], "deconfig"))
		return deconfig_lan();
	else if (strstr(argv[1], "bound"))
		return bound_lan();
	else if (strstr(argv[1], "renew"))
		return renew_lan();
	else
		return EINVAL;
}
#endif	/* __CONFIG_NAT__ */
